# $Id: snmp.tcl,v 1.5 2001/02/26 14:05:17 gdmr Exp $
#
# Copyright 2000 Division of Informatics, University of Edinburgh
# 
# Permission to use, copy, modify, distribute, and sell this software and its
# documentation for any purpose is hereby granted without fee, provided that
# the above copyright notice appear in all copies and that both that
# copyright notice and this permission notice appear in supporting
# documentation, and that the name of the University of Edinburgh not be used
# in advertising or publicity pertaining to distribution of the software
# without specific, written prior permission.  The University of Edinburgh
# makes no representations about the suitability of this software for any
# purpose.  It is provided "as is" without express or implied warranty.
#
# SNMP-based procedures to query the switches.  Cache the results
# where appropriate.
#

####################
# Initialisation
####################

puts "Loading Tnm..."
package require Tnm 3.0
namespace import Tnm::snmp
namespace import Tnm::mib

# To speed up loading we pare things down to the bare minimum
#set tnm(mibs) "MAU-MIB BRIDGE-MIB RMON-MIB"
#set mibList {}
#
#puts "MIBs: $mibList"
#foreach m $mibList {
#   mib load [file join [file dirname $argv0] $m]
#}

set snmpRetries 1
set snmpTimeout 3

proc snmpInit {host community} {
   global snmpRetries
   global snmpTimeout
   snmp generator \
         -address $host -community $community \
         -retries $snmpRetries -timeout $snmpTimeout
}

####################
# System group
####################

proc snmpDescrLoc {snmpS} {
   set vbl "SNMPv2-MIB!sysDescr.0
            SNMPv2-MIB!sysLocation.0"
   set vbl [$snmpS get $vbl]
   snmp value $vbl
}

proc snmpUpTime {snmpS} {
   set vb "SNMPv2-MIB!sysUpTime.0"
   set vb [$snmpS get $vb]
   set v [snmp value $vb]
   # Divide by 100 by chopping the last two digits off the end of
   # the timeticks value...
   string range $v 0 [expr [string length $v] - 3]
}
